unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ExtCtrls, StdCtrls,
  TAGraph, TASeries;

type
  
  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Chart1: TChart;
    Chart1LineSeries1: TLineSeries;
    Panel1: TPanel;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    procedure Button1Click(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

uses
  Math;

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
const
  N = 100;
var
  i: Integer;
  x, y: Double;
begin
  Chart1LineSeries1.Clear;
  if RadioButton1.Checked then
  begin
    for i := 0 to N-1 do
    begin
      x := i*1.3;
      if x - 3.9 <> 0 then
        y := 1/(x - 3.9)
      else
        y := NaN;
      Chart1LineSeries1.AddXY(x, y);
    end;
  end;
  if RadioButton2.Checked then
  begin
    for i := 0 to N-1 do
    begin
      x := i*1.3;
      if not IsZero(x - 3.9) then
        y := 1/(x - 3.9)
      else
        y := NaN;
      Chart1LineSeries1.AddXY(x, y);
    end;
  end;
end;

end.

